package de.intevation.flys.artifacts.model.fixings;

import de.intevation.flys.artifacts.access.FixRealizingAccess;

import de.intevation.flys.artifacts.math.fitting.Function;

import de.intevation.flys.artifacts.model.CalculationResult;
import de.intevation.flys.artifacts.model.FixingsOverview;
import de.intevation.flys.artifacts.model.Segment;

import java.util.List;

import org.apache.log4j.Logger;

public class FixRealizingCalculation
extends      FixCalculation
{
    private static Logger log =
        Logger.getLogger(FixRealizingCalculation.class);

    protected boolean       isQ;
    protected List<Segment> segments;

    public FixRealizingCalculation() {
    }

    public FixRealizingCalculation(FixRealizingAccess access) {
        super(access);

        Boolean       isQ      = access.isQ();
        List<Segment> segments = access.getSegments();

        if (isQ == null) {
            // TODO: i18n
            addProblem("fix.realize.missing.is.q");
        }

        if (segments == null || segments.isEmpty()) {
            // TODO: i18n
            addProblem("fix.realize.missing.segments");
        }

        if (!hasProblems()) {
            this.isQ      = isQ;
            this.segments = segments;
        }
    }

    @Override
    protected CalculationResult innerCalculate(
        FixingsOverview overview,
        Function        func
    ) {
        // TODO: Implement me!
        return new CalculationResult(this);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
